const TAG_SUGGEST_CONTRACTID = "@mozilla.org/autocomplete/search;1?name=gbb-tag-suggest";
const TAG_SUGGEST_CLASSNAME = "GBB Tag Suggest";
const TAG_SUGGEST_CLASSID = Components.ID("{3f6578c0-3df8-11db-a98b-0800200c9a66}");

function TagSuggestAutoCompleteResult(searchString, searchResult, defaultIndex, 
                                   errorDescription, results, comments) {
	//throw searchString+' ; '+searchResult+' ; '+defaultIndex+' ; '+errorDescription+' ; '+results+' ; '+comments;
	this._searchString = searchString;
  this._searchResult = searchResult;
  this._defaultIndex = defaultIndex;
  this._errorDescription = errorDescription;
  this._results = results;
  this._comments = comments;
}
TagSuggestAutoCompleteResult.prototype = {
  _searchString: "",
  _searchResult: 0,
  _defaultIndex: 0,
  _errorDescription: "",
  _results: [],
  _comments: [],
  
  get searchString() {
    return this._searchString;
  },
  get searchResult() {
    return this._searchResult;
  },
  get defaultIndex() {
    return this._defaultIndex;
  },
  get errorDescription() {
    return this._errorDescription;
  },
  get matchCount() {
    return this._results.length;
  },
  getValueAt: function(index) {
    return this._results[index];
  },
  getCommentAt: function(index) {
    return this._comments[index];
  },
  getStyleAt: function(index) {
    return null;
  },
  removeValueAt: function(index, removeFromDatabase) {
    this._results.splice(index, 1);
    this._comments.splice(index, 1);
  },
  QueryInterface: function(iid) {
  	throw '!';
    if (!iid.equals(Components.interfaces.nsIAutoCompleteResult) &&
        !iid.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;    
    return this;
  }  
};

function TagSuggestAutoComplete() { }
TagSuggestAutoComplete.prototype = {
  startSearch: function(searchString, searchParam, previousResult, listener) {
		if (listener) {

		var s = this.readLabelsFromFile();
		var str = searchString;
		var sa = new Array();
		var preString = str.substring(0, str.lastIndexOf(','))+',';
		var needle = str.substring(str.lastIndexOf(',')+1, str.length).replace(/^\s+|\s+$/, '');
		var labelArray = s.split(',');//window.opener.gbb_BookmarkArray.getLabels(needle);
		function sortstr(a,b) {
		    aa = a.toLowerCase();
		    bb = b.toLowerCase();
		    if (aa==bb) return 0;
		    if (aa<bb) return -1;
		    return 1;
		}		
		labelArray.sort(sortstr);

		for (var i = 0; i < labelArray.length; i++) {			
			var aux_str = labelArray[i].toUpperCase();
			if (aux_str.indexOf(needle.toUpperCase()) == 0) {
				if (preString.indexOf(labelArray[i]+',') > -1) {
					continue;
				}else{
					if (preString.length > 1)
						var label = preString+' '+labelArray[i];
					else
						var label = labelArray[i];
					sa.push(label);				
					//bookmarkLabelsCaption.appendItem(label, '');
				}
			}
		}

			//var sa = s.split(',');
      var result = new TagSuggestAutoCompleteResult(searchParam, 
                                                 Components.interfaces.nsIAutoCompleteResult.RESULT_SUCCESS,
                                                 0, "", sa, [str]);
      listener.onSearchResult(this, result);
    }else{
			throw '!';
		}
	},
	
  stopSearch: function() {
  },

	readLabelsFromFile : function() {
			fileFlags = {
				// From http://lxr.mozilla.org/mozilla/source/nsprpub/pr/include/prio.h#600
				RDONLY: 0x01,
				WRONLY: 0x02,
				RDWR: 0x04,
				CREATE_FILE: 0x08,
				APPEND: 0x10,
				TRUNCATE: 0x20,
				SYNC: 0x40,
				EXCL: 0x80
			};
			
			fileMode = 0660;
			
			const id = "{0dad0080-ca5a-11da-a94d-0800200c9a66}";
			var labelsFile = Components.classes["@mozilla.org/extensions/manager;1"]
			                    .getService(Components.interfaces.nsIExtensionManager)
			                    .getInstallLocation(id)
			                    .getItemLocation(id); 
			labelsFile.append('chrome');
			labelsFile.append('content');
			labelsFile.append('google-bookmarks-button');
			labelsFile.append('tags.dat');
			//var saveFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
			//saveFile.initWithFile(saveFileName);
			if (labelsFile.exists()) {
				var aLocalStream = Components.classes['@mozilla.org/network/file-input-stream;1'].
							createInstance(Components.interfaces.nsIFileInputStream);
				aLocalStream.init(labelsFile, fileFlags.RDONLY, fileMode, 0);
				var aLocalScriptStream = Components.classes['@mozilla.org/scriptableinputstream;1'].
							createInstance(Components.interfaces.nsIScriptableInputStream);
				aLocalScriptStream.init(aLocalStream);
				var s = aLocalScriptStream.read(aLocalScriptStream.available());
				aLocalStream.close();
			}else{
				throw 'File "'+labelsFile.path+'"" doesn\'t exists';
			}
			return s;	
	},
		
  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsIAutoCompleteSearch) &&
        !iid.equals(Components.interfaces.nsIAutoCompleteObserver) &&
        !iid.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
		return this;
  }
}

// Constructor
function xTagSuggestAutoComplete() { }
xTagSuggestAutoComplete.prototype = {
  __proto__: TagSuggestAutoComplete.prototype,
};

var myModule = {
  mCID: TAG_SUGGEST_CLASSID,
  mContractID: TAG_SUGGEST_CONTRACTID,
  
	registerSelf: function (compMgr, fileSpec, location, type) {
	    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
	    compMgr.registerFactoryLocation(this.mCID,
	                                    TAG_SUGGEST_CLASSNAME,
	                                    this.mContractID,
	                                    fileSpec,
	                                    location,
	                                    type);
	  },

	getClassObject: function (compMgr, cid, iid) {
    if (!cid.equals(this.mCID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return this.mFactory;
  },
  
	mFactory: {
    createInstance: function (outer, iid) {
      if (outer != null)
        throw Components.results.NS_ERROR_NO_AGGREGATION;
      return (new xTagSuggestAutoComplete()).QueryInterface(iid);  // (use your implementation object name)
    }
  }, 

  canUnload: function(compMgr) {
    return true;
  }
};

function NSGetModule(componentManager, location) {	
  // Metadata about the objects this module can construct
  return myModule;
}

